<template>
  <div class="order-step">
    <div class='order-step__rout-info'>
      <component
        :is="activeComponent"
        :logchain="logchainWithReplaceable"
        :actualTariff="formData.actualTariff"
        :contractNumber="formData.services.contractNumber || ''"
        :replaceableServices="replaceableServices"
        :primeCost="formData.primeCost"
        @serviceReplaced="$emit('serviceReplaced', $event)"
        mode="page"
      />
    </div>
    <order-consignee-consignor
      :isValid="isConsigneeConsignorValid"
      :brif="brif"
      :baseLocations="baseLocations"
      :addresses="addresses"
      :locationsTypes="locationsTypes"
      :contractorUuid="formData.bodySaveDraft.client.uuid"
      :pvpDate="pvpDate"
      @visit-point-updated="$emit('visit-point-updated')"
    />

    <payment-info
        @showPaymentInfo="$emit('showPaymentInfo', $event)"
        @isValidPaymentInfo="$emit('isValidPaymentInfo', $event)"
    />

    <div class="order-step__comments">
      <h2 class="order-step-title">
        Комментарий
      </h2>
      <ob-input
        v-model="form.parameters.comments"
        label="Комментарий"
        placeholder="Будет виден всем перевозчикам"
        data-qa="comments"
        @blur="saveComment"
      />
    </div>
    <div class="order-step__misc">
      <h2 class="order-step-title">
        Дополнительно
      </h2>
      <div class="order-step__misc-items">
        <div class="order-step__misc-item" @click="toggleParametersVisibility">
          <button data-qa="btnParameters" :class="{ closed: !parametersExpanded }">
            <i class="icon chevron-up"></i>
          </button>
          <span>Параметры</span>
        </div>
        <expand-transition scrollIntoView>
          <div v-if="parametersExpanded">
            <div class="order-cargo-type">
              <h2 :class="{ active: validation.isCargoCodeValid }" class="order-step-title">
                Код и наименование груза
              </h2>
              <ob-select
                v-model="form.cargo.etsngs"
                :remote-opt="{
                  method: getCargoCodes
                }"
                :details-remote="{
                  method: getCargoCode
                }"
                label="ЕТСНГ"
                placeholder="Введите код и наименование груза"
                icon="plus"
                is-auto-complete
                :disabled="formData.bodySaveDraft.transportationWay !== 'FTL'"
                displayExp="denomination"
                data-qa="cargoCodesSelect"
                @input="onCargoCodeChanged"
              />
            </div>
            <div class="order-step__weight">
              <h2 class="order-step-title">
                Вес и объём груза
              </h2>
              <div class="input-group">
                <ob-input
                  ref="weight"
                  v-model.number="form.cargo.weightInKg"
                  type="number"
                  :isTrimOnBlur="false"
                  :disabled="form.bodySaveDraft.transportationWay === 'CONTAINER' || form.bodySaveDraft.transportationWay === 'RAIL'"
                  class="max200 --small"
                  placeholder="Укажите вес"
                  label="Общий вес груза"
                  subTitle="кг"
                  data-qa="weightInKg"
                  @input="onWeightChanged"
                />
                <ob-input
                  v-model.number="form.cargo.volumeInCubicMeters"
                  type="number:strict"
                  :isTrimOnBlur="false"
                  :disabled="form.bodySaveDraft.transportationWay === 'CONTAINER' || form.bodySaveDraft.transportationWay === 'RAIL'"
                  class="max200"
                  placeholder="Укажите объём"
                  label="Общий объём груза"
                  subTitle="м³"
                  data-qa="volumeInCubicMeters"
                  @input="onCargoChanged('volumeInCubicMeters')"
                />
                <ob-input
                  v-model.number="form.cargo.palletCount"
                  type="number:strict"
                  :isTrimOnBlur="false"
                  class="max200"
                  placeholder="Укажите кол-во"
                  label="Количество паллет"
                  :disabled="form.bodySaveDraft.transportationWay === 'CONTAINER' || form.bodySaveDraft.transportationWay === 'RAIL'"
                  subTitle="пл"
                  data-qa="palletCount"
                  @input="onCargoChanged('palletCount')"
                />
              </div>
            </div>
            <div class="accounting">
              <ob-select
                v-model="form.cargo.freightForwardingUnitUuid"
                label="Единица экспедиторского учёта"
                placeholder="Выберите из списка"
                :items="accountingItems"
                :disabled="form.bodySaveDraft.transportationWay === 'CONTAINER' || form.bodySaveDraft.transportationWay === 'RAIL'"
                data-qa="freightForwardingUnit"
                @input="onFreightForwardingUnitUuidChanged"
              />
            </div>
            <div class="order-step__contacts">
              <h2
                :class="{ active: true }"
                class="order-step-title"
              >
                Номер заказа клиента и контактное лицо
              </h2>
              <div class="input-group">
                <ob-input
                  v-model="form.bodySaveDraft.externalNumber"
                  :isTrimOnBlur="false"
                  label="№ заказа клиента"
                  placeholder="Введите номер заказа клиента"
                  data-qa="externalNumber"
                  @input="onNumberChanged()"
                />
                <ob-select
                  v-model="form.parameters.contactPerson.fio"
                  label="Контактное лицо клиента"
                  placeholder="Выберите из списка"
                  :items="contacts"
                  valueExp="title"
                  :isStandart="true"
                  data-qa="contactPerson"
                  @input="onContactChanged()"
                  :itemBottom="{
                    icon: 'plus',
                    title: `Добавить контактное лицо`
                  }"
                  @bottom="$refs.addContactModal.open"
                />
                <ob-select
                  v-if="form.parameters.contactPerson.fio"
                  v-model="form.parameters.contactPerson.phone"
                  label="Способ связи"
                  placeholder="Номер телефона, добавочный номер"
                  :items="phones"
                  :isStandart="true"
                  valueExp="title"
                  data-qa="contactPerson"
                  @input="onContactPhoneChanged()"
                  :itemBottom="{
                    icon: 'plus',
                    title: `Добавить способ связи`
                  }"
                  @bottom="$refs.addContactPhoneModal.open"
                />
              </div>
            </div>
            <div class="order-step__security">
              <h2 class="order-step-title">
                Требования к сервису и безопасности
              </h2>
              <ob-select
                v-model="form.parameters.serviceRequirements"
                label="Если хотите, выберите из списка дополнительные требования"
                placeholder="Выберите из списка"
                icon="plus"
                :items="securityItems"
                :is-tagbox="true"
                :is-multiselect="true"
                :isDropdown="true"
                data-qa="serviceRequirements"
                @input="onSecurityChanged"
              />
            </div>
          </div>
        </expand-transition>
        <div
          class="order-step__misc-item "
          @click="toggleServicesVisibility"
        >
          <button data-qa="btnServices" :class="{ closed: !servicesExpanded }">
            <i class="icon chevron-up"></i>
          </button>
          <span>Услуги</span>
        </div>
        <expand-transition scrollIntoView>
          <div class="order-step__services" v-if="servicesExpanded">
            <h2 class="order-step-title">
              Перевозка по маршруту {{services.titleGeoraphy}}
            </h2>
            <p v-if="services.contractNumber">
              по договору
              <router-link :to="`/contract/${formData.logchain.tariff.contractUuid}`">№{{ services.contractNumber }}</router-link>
              от {{services.contractEffectiveD}}
            </p>
            <div class="order-step__service-items">
              <h2 class="order-step-title order-step-title--services">
                Базовые услуги
                <span>
                  {{ new Intl.NumberFormat('ru-RU').format(Math.round(formData.actualTariff.baseServicePrice / 100)) }} ₽
                  <template v-if="formData.actualTariff.vatInPercents && formData.actualTariff.vatInPercents > 0"> без НДС, НДС: {{ new Intl.NumberFormat('ru-RU').format(Math.round(((formData.actualTariff.baseServicePrice / 100) * this.formData.bodySaveDraft.vat) / 100)) }} ₽</template>
                  <template v-else>, НДС не облагается</template>
                </span>
              </h2>
              <div class="base-services">
                <div class="order-step__service-route">
                  <button
                    :class="{ closed: !baseServicesExpanded }"
                    data-qa="btnBaseServices"
                    @click="toggleBaseServicesVisibility"
                  >
                    <i class="icon chevron-up"></i>
                  </button>
                  {{services.titleGeoraphy}}
                </div>
                <expand-transition scrollIntoView>
                  <div v-if="baseServicesExpanded">
                    <table v-if="services.baseServices.length">
                      <thead>
                        <tr>
                          <th></th>
                          <th>наименование</th>
                          <th>география</th>
                          <th class="number">кол-во</th>
                          <th class="number">сумма без ндс, ₽</th>
                          <th class="number">ндс, ₽</th>
                          <th class="number">итоговая сумма, ₽</th>
                        </tr>
                      </thead>
                      <tbody :class="{ __disabled: this.contractor.roleCode === 'CARRIER' }">
                        <tr
                          v-for="(service, index) in services.baseServices"
                          :key="service.uuid"
                        >
                          <td>
                            <ob-checkbox
                              label=""
                              :value="service.isChoosen === null ? true : service.isChoosen"
                              :disabled="service.isChoosen === null"
                              :data-qa="'chkService_' + index"
                              @change="onBaseServiceChange($event, service)"
                            />
                          </td>
                          <td>{{ service.baseServiceClientName }}</td>
                          <td>{{service.geography}}</td>
                          <td class="number">
                            <template v-if="service.isEditableCount">
                              <stepper-round
                                v-model="service.count"
                                maxVal=12
                                @input="onTransportCountChange($event, service)"
                              />
                            </template>
                            <template v-else>
                              {{ service.count }}
                            </template>
                          </td>
                          <td class="number">{{ service.price > 0 ? new Intl.NumberFormat('ru-RU').format(Math.round(service.price / 100)) : "–" }}</td>
                          <td class="number">—</td>
                          <td class="number">—</td>
                        </tr>
                      </tbody>
                    </table>
                    <p v-else>Нет сервисов</p>
                  </div>
                </expand-transition>
              </div>
            </div>
          </div>
        </expand-transition>
      </div>
    </div>
    <ob-modal
      ref="addContactModal"
      size="small"
      title="Новое контактное лицо"
      data-qa="addContactModal"
    >
      <ob-form
        @submit="createContact"
        :formData="newContact"
        data-qa="newContactForm"
        okText="Добавить"
      >
        <ob-input
          placeholder="Контактное лицо"
          label="ФИО"
          v-model="newContact.fio"
          data-qa="newContact"
        />
      </ob-form>
    </ob-modal>

    <ob-modal
      ref="addContactPhoneModal"
      size="small"
      title="Способ связи"
      custom-class="add-contact-modal"
      data-qa="addContactPhoneModal"
    >
      <p>
        Укажите способ, как можно связаться с этим человеком. Например, телефон с добавочным номером, емэйл, какое-либо примечание
      </p>
      <div>
        <ob-form
          @submit="createContactPhone"
          :formData="newContactPhone"
          okText="Добавить"
          data-qa="newContactPhoneForm"
        >
          <ob-input
            placeholder="Номер телефона, добавочный номер"
            label="Способ связи"
            v-model="newContactPhone.phone"
            data-qa="newContactPhone"
          />
        </ob-form>
      </div>
    </ob-modal>
  </div>
</template>

<script>
import api from "@/api";
import cloneDeep from 'clone-deep'
import debounce from 'debounce';
import {mapGetters} from "vuex";
import { getNumberRisk } from '@/helpers/risks';
import { sortRisks } from '@/helpers/risks';
import json from '@/order-mock.json';
import expandTransition from '../ExpandTransition';
import orderConsigneeConsignor from './orderConsigneeConsignor';
import obSelect from 'common-components/src/obComponents/obSelect';
import obInput from 'common-components/src/obComponents/obInput';
import obRadio from 'common-components/src/obComponents/obRadio';
import obCheckbox from 'common-components/src/obComponents/obCheckbox';
import LogchainCard from '../../components/Order/logchainCard';
import ClicarLogchainCard from '../../components/Order/clicarLogchainCard';
import obModal from 'common-components/src/obComponents/obModal';
import obForm from 'common-components/src/obComponents/obForm';
import stepperRound from '../../components/stepper-round';
import riskMixin from '@/mixins/risk-icon'
import paymentInfo from "@/components/Order/paymentInfo";

export default {
  mixins: [
    riskMixin
  ],
  components: {
    obSelect,
    obInput,
    expandTransition,
    obRadio,
    obCheckbox,
    LogchainCard,
    ClicarLogchainCard,
    orderConsigneeConsignor,
    obModal,
    obForm,
    stepperRound,
    paymentInfo,
  },

  props: {
    replaceableServices: {
      type: Array,
      default: () => []
    },
    logchain: {
      type: Object,
      required: true
    },
    cargoTypes: {
      type: Array,
      required: true
    },
    formData: {
      type: Object,
      required: true
    },
    validation: {
      type: Object,
      required: true
    },
    securityItems: {
      type: Array,
      required: true
    },
    accountingItems: {
      type: Array,
      required: true
    },    
    contacts: {
      type: Array,
      required: true
    },
    phones: {
      type: Array,
      default: () => []
    },
    brif: {
      type: Object,
      required: true,
    },
    baseLocations: {
      type: Object,
      required: true,
    },
    addresses: {
      type: Object,
      required: true,
    },
    locationsTypes: {
      type: Array,
      required: true
    },
    services: {
      type: Object,
      required: true
    },
    errors: {
      type: Array,
      default: () => []
    },
    contractor: {
      type: Object,
      required: true
    }
  },

  riskColorsMap: {
    'GREEN': 'risk-1-blue',
    'BLUE': 'risk-2-green',
    'YELLOW': 'risk-3-yellow',
    'ORANGE': 'risk-4-orange',
    'RED': 'risk-5-red',
    'BLACK': 'risk-6-black'
  },
  data() {
    return {
      weight: 0,
      newContact: {
        fio: ''
      },
      newContactPhone: {
        phone: ''
      },
      mocks: json,
      form: '',
      parametersExpanded: false,
      activeSecurity: '',
      servicesExpanded: false,
      baseServicesExpanded: false,
    }
  },

  computed: {
    ...mapGetters({
      role: 'user/role'
    }),
    pvpDate() {
      const point = this.logchain?.points?.find(item => item.ordinal === 1);
      return point.eta_dt;
    },
    logchainWithReplaceable() {
      if (!this.replaceableServices) {
        return this.logchain;
      }
      const whichPoints = this.replaceableServices.reduce((acc, item) => {
          acc[item.ordinal] = acc[item.ordinal] ? [...acc[item.ordinal], item] : [item];
          return acc;
        }, {});
        const logchain = cloneDeep(this.logchain);
        logchain?.points?.forEach(point => {
          point.replaceableServices = whichPoints[point.ordinal];
          if (point.replaceableServices && point.replaceableServices.length > 0) {
            if (!point.serviceUuid) {
              const target = whichPoints[point.ordinal].find(item => item.isUsed === true);
              point.serviceUuid = target.logchainPointServiceUuid
            }
          }
        })
        return logchain;
    },
    activeComponent() {
      let componentsMap = {
        client: LogchainCard,
        clicar: ClicarLogchainCard,
        anonymous: LogchainCard
      };
      return componentsMap[this.role]
    },
    carrierRisks() {
      return this.carrierColors.map((item) => {
        return this.getNumberRisk(item)
      }).join('-')
    },

    carrierColors () {
      return this.formData.bodySaveDraft.acceptedCarrierColors ? this.sortRisks({ data: this.formData.bodySaveDraft.acceptedCarrierColors }) : []
    },

    platformTotal() {
      return 0;
    },

    baseTotal() {
      return this.services.baseServices
        .reduce((acc, item) => acc + item.price, 0)
    },
    isConsigneeConsignorValid() {
      return Boolean(
        this.validation.isConsigneeValid &&
        this.validation.isConsignorValid
      );
    },
  },

  watch: {
    formData: {
      handler: function(newVal) {
        this.form = {...newVal };
      },
      immediate: true,
      deep: true
    },
  },

  methods: {
    getNumberRisk,
    sortRisks,
    async getCargoCode() {
      try {
        const extra = await api.orders.getCargoCode({uuids: Array.isArray(this.form.cargo.etsngs) ? [] : [this.form.cargo.etsngs]});
        const temp = extra.values.map(item => {
          return {
            code: item.code,
            denomination: `${item.code} ${item.title}`,
            uuid: item.uuid
          }
        })

        return temp;
      } catch(e) {
          console.error(e);
        }
    },
    async getCargoCodes({ page, size, query }) {
      try {
        const res = await api.orders.getCargoCodes({ page, size, query });
        res.content = res.content.map((item) => {
          return {
            code: item.code,
            denomination: `${item.code} ${item.denomination}`,
            uuid: item.uuid,
          };
        });
        return res;
      } catch (e) {
        console.error(e);
      }
    },
    createContact($event) {
      this.$emit('contactAdded', $event);
      this.$refs.addContactModal.close();
    },

    createContactPhone($event) {
      this.$emit('contactPhoneAdded', $event);
      this.$refs.addContactPhoneModal.close();
    },

    onCargoTypeChange() {
      this.$emit('cargoTypeChanged', this.form.parameters.cargoTypeUuid);
    },

    onInsuranceCostChange() {
      this.$emit('insuranceCostChanged', this.form.parameters.insuranceCargo.cost);
    },

    onCommentsChanged() {
      this.$emit('commentsChanged', this.form.parameters.comments);
    },

    saveComment() {
      this.$emit('commentsChanged', this.form.parameters.comments);
    },

    onCargoCodeChanged() {
      this.$emit('cargoCodeChanged', this.form.cargo.etsngs);
    },

    onWeightChanged() {
      this.$emit('weightChanged', this.form.cargo.weightInKg);
    },

    onCargoChanged(field) {      
      this.$emit('cargoChanged', {field, value: this.form.cargo[field]});
    },

    onNumberChanged() {
      this.$emit('numberChanged', this.form.bodySaveDraft.externalNumber);
    },

    onContactChanged() {
      this.$emit('contactChanged', this.form.parameters.contactPerson.fio);
    },

    onContactPhoneChanged() {
      this.$emit('contactPhoneChanged', this.form.parameters.contactPerson.phone);
    },

    onSecurityChanged() {
      this.$emit('securityChanged', this.form.parameters.serviceRequirements);
    },

    capitalize(string) {
      return string.charAt(0).toUpperCase() + string.slice(1);
    },

    onFreightForwardingUnitUuidChanged() {
      this.$emit('freightForwardingUnitUuidChanged', this.form.cargo.freightForwardingUnitUuid)
    },

    toggleParametersVisibility() {
      this.parametersExpanded = !this.parametersExpanded;
    },

    toggleServicesVisibility() {
      this.servicesExpanded = !this.servicesExpanded;
    },

    toggleBaseServicesVisibility() {
      this.baseServicesExpanded = !this.baseServicesExpanded;
    },

    isServiceActive(name) {
      return !!this.mocks.selectedServices.filter(item => item.name === name)
        .length;
    },

    onServiceChanged($event) {
      if ($event.status) {
        const newService = { ...$event.event, type: 'platform' };
        this.mocks.selectedServices.push(newService);
        this.$emit('serviceChanged', $event);
        return;
      }

      this.mocks.selectedServices = this.mocks.selectedServices.filter(
        item => item.name !== $event.event.name
      );
      this.$emit('serviceChanged', $event);
    },

    onBaseServiceChange($event, service) {
      service.isChoosen = $event;
      this.$emit('serviceChanged', service);
    },

    onTransportCountChange: debounce(function($event, service) {
      service.count = $event;
      this.$emit('transportCountChanged', service)
    }, 500)
  },

  directives: {
    int: {
      bind: function(el, binding, vnode) {
        const _this = vnode.context;
        el.addEventListener("keydown", e => {
          if (
            [46, 8, 9, 27, 13].indexOf(e.keyCode) !== -1 ||
            // Allow: Ctrl+A
            (e.keyCode === 65 && e.ctrlKey === true) ||
            // Allow: Ctrl+C
            (e.keyCode === 67 && e.ctrlKey === true) ||
            // Allow: Ctrl+X
            (e.keyCode === 88 && e.ctrlKey === true) ||
            // Allow: home, end, left, right
            (e.keyCode >= 35 && e.keyCode <= 39)
          ) {
            return;
          }

          const val = _this.$refs.weight.value + '';
          if (val.length >= 4) {
            e.preventDefault();
          }
          const findDot = new RegExp(/\./g)
          const containsDot = val.match(findDot)
          if (val && containsDot) {
            const dec = val.split('.')
            if (dec[1].length >= 1) {
              e.preventDefault();
            }
          }
        });
      }
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.order-step {
  padding: 0 19px 10px !important;
}

.order-step__rout-info {
  margin: 0 -20px 0;
  // height: 200px;
  width: calc(100vw - 356px);
  background-color: $background-white;
  display: flex;
  justify-content: center;
  align-items: center;
  box-shadow: 0px 4px 16px rgba($color-blue-navy-blue, 0.2);
  border-radius: 4px;
  font-size: 24px;
}

.order-step__weight {
  margin-top: 29px;

  .order-step-title {
    margin: 0 0 18px;
  }
}

.input-group {
  display: flex;
  margin-bottom: 24px;
  flex-wrap: wrap;

  .ob-selector {
    margin-bottom: 0;
  }

  div:first-child:not(.--small) {
    flex-grow: 1;
    max-width: 607px
  }

  & > * {
    margin-right: 20px;
  }
}

.order-step__misc {
  margin-top: 40px;
}

.order-step__misc-item {
  padding: 0 17px;
  display: flex;
  align-items: center;
  height: 40px;
  background-color: $light-lavender;
  @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
  border-bottom: 1px solid $components-orderSecondScreen_order-step_misc-item_border-bottom;

  button {
    margin-right: 18px;
    border: none;
    outline: none;
    background-color: transparent;
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
    font-size: 16px;
    color: $color-blue-navy-blue;
    -webkit-transition: all 0.2s ease-in-out;
    transition: all 0.2s ease-in-out;
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);

    .chevron-up {
      display: inline-block;
      transform: rotate(180deg);
    }
  }

  .closed .chevron-up {
    transform: rotate(90deg);
  }
}

.accounting {
  display: flex;

  .ob-selector {
    margin-right: 22px;
    max-width: 390px;
  }
}

.order-step__type {
  margin-top: 40px;

  .ob-selector {
    max-width: 653px;
  }
}

.order-ensurance {
  margin-top: 20px;
  display: flex;
  align-items: center;

  .ob-input-container {
    width: 100%;
    max-width: 317px;
  }
}

.order-step__contacts,
.order-step__comments {
  margin-top: 36px;
}

.order-step__security {
  margin-top: 40px;
  margin-bottom: 16px;
}

.order-step__services {
  margin-top: 40px;
}

.order-step__service-items {
  margin-top: 60px;
}

.platform-services {
  display: flex;
  margin-bottom: 40px;

  & > .service {
    flex: 0 0 164px;

    &:not(:last-child) {
      margin-right: 9px;
    }
  }
}

.order-step__service-route {
  padding: 24px;
  font-size: 12px;
  color: $color-text-base;
  background-color: $background-color-light;

  button {
    margin-right: 28px;
    border: none;
    outline: none;
    background-color: transparent;
    appearance: none;
    font-size: 16px;
    color: $color-blue-navy-blue;
    transition: all 0.2s ease-in-out;
  }

  .chevron-up {
    display: inline-block;
    transform: rotate(180deg);
  }

  .closed .chevron-up {
    transform: rotate(90deg);
  }
}

table {
  width: 100%;
  text-align: left;
  font-size: 14px;
  color: $color-text-base;
  border: 1px solid $lavender;

  th {
    padding: 10px;
    font-size: 11px;
    color: $shale-gray;
    text-transform: uppercase;
    font-weight: 400;

    &:first-child {
      width: 5%;
    }

    &:nth-child(2) {
      width: 40%;
    }

    &:nth-child(3) {
      width: 20%;
    }

    &:nth-child(4) {
      width: 10%;
    }

    &:last-child {
      width: 15%;
    }
  }

  td {
    padding: 10px;
    border-top: 1px solid $lavender;
  }

  .number {
    text-align: right;
  }
}

.services-list {
  margin-bottom: 20px;
  margin-top: 17px;
  font-weight: 400;

  li {
    display: flex;
    align-items: center;
    justify-content: space-between;
    font-size: 12px;

    &:not(:last-child) {
      margin-bottom: 9px;
    }
  }
}

.order-step__actions {
  display: flex;
  align-items: center;
  margin: 30px 0;
  background-color: pink;
}

.order-cargo-type {
  margin-top: 20px;
}

::v-deep {
  .ob-card {
    &:not(:last-child) {
      margin-bottom: 10px;
    }
  }

  .ob-card-path .ob-card-path-container .ob-card-path-top-header .ob-card-path-top-header-tag,
  .ob-card-path .ob-card-path-main-header .ob-card-path-header-info .ob-card-path-header-info-carrier {
    display: none;
  }

  .error {
    .ob-input-wrap.--theme-default[data-v-f8ef9e06],
    .ob-selector__select,
    .ob-selector__select_open {
      border-radius: 3px;
      border: 1px solid $color-error !important;
    }

    .ob-selector__controls .icon {
      color: $color-error;
    }
  }

  .ob-card-path {
    width: 100%;
  }
}

.input-error {
  padding: 19px 20px 12px;
  margin-top: 20px;
  width: 100%;
  display: flex;
  align-items: center;
  background-color: rgba($color-error, 0.1);
  @include font-mixin(14px, 20px, 400, $color-text-base);

  .icon {
    margin-right: 20px;
    position: relative;
    top: 2px;
    font-size: 24px;
    color: $color-error;
  }
}

.order-insurance {
  display: flex;
  align-items: center;
}

.order-insurance__risk {
  margin-left: 10px;
  display: flex;
  align-items: center;

  .icon {
    font-size: 20px;
    margin-right: 7px;
    color: $components-orderSecondScreen_order_insurance_risk_icon;
  }
}

.max200 {
  max-width: 200px;
}

 .__disabled {
  opacity: 0.5;
  pointer-events: none;
  user-select: none;
}

.add-contact-modal {
  .modal-body p {
    margin-bottom: 20px;
    @include font-mixin(14px, 18px, 400, $gray-slate);
  }
}
</style>